Index: test/Makefile
===================================================================
--- test/Makefile	(revision 9864)
+++ test/Makefile	(working copy)
@@ -80,6 +80,7 @@
 	resize.cxx \
 	rotated_text.cxx \
 	scroll.cxx \
+	shadow_varaibles.cxx \
 	shape.cxx \
 	subwindow.cxx \
 	sudoku.cxx \
@@ -148,6 +149,7 @@
 	resizebox$(EXEEXT) \
 	rotated_text$(EXEEXT) \
 	scroll$(EXEEXT) \
+	shadow_variables$(EXEEXT) \
 	subwindow$(EXEEXT) \
 	sudoku$(EXEEXT) \
 	symbols$(EXEEXT) \
@@ -196,6 +198,7 @@
 	$(RM) keyboard_ui.cxx keyboard_ui.h
 	$(RM) mandelbrot_ui.cxx mandelbrot_ui.h
 	$(RM) preferences.cxx preferences.h
+	$(RM) shadow_variables.cxx
 	$(RM) radio.cxx radio.h
 	$(RM) resize.cxx resize.h
 	$(RM) tabs.cxx tabs.h
@@ -509,6 +512,21 @@
 	$(CXX) $(ARCHFLAGS) $(LDFLAGS) -o $@ gl_overlay.o $(LINKFLTKGL) $(LINKFLTK) $(GLDLIBS)
 	$(OSX_ONLY) ../fltk-config --post $@
 
+# shadow_variables [STR #2728] 
+#	Use the g++ compiler's -Wshadow feature to check for shadowed variables.
+#	This test is not meant to be executed, but simply 'compileable without warnings'.
+#	Compiler warnings are meant to caution devs about shadowed variables.
+#
+shadow_variables.cxx: Makefile
+	echo '#include <stdio.h>' > shadow_variables.cxx
+	(cd ..; perl -e 'opendir(DIR,"FL/"); foreach(sort(readdir(DIR))) { if( /\.H$$/ && !/^mac.H$$/ && !/^win32.H$$/ && !/^x.H$$/) {print "#include <FL/$$_>\n"; } }' ) >> shadow_variables.cxx
+	echo 'int main() { return(0); }' >> shadow_variables.cxx
+
+ifeq ($(CXX),g++)
+shadow_variables: shadow_variables.cxx
+	-$(CXX) -I.. -Wshadow $(ARCHFLAGS) $(LDFLAGS) $< -o $@ $(LINKFLTK)
+endif
+
 shape$(EXEEXT): shape.o
 	echo Linking $@...
 	$(CXX) $(ARCHFLAGS) $(LDFLAGS) -o $@ shape.o $(LINKFLTKGL) $(LINKFLTK) $(GLDLIBS)
